%%%% Matlab code for Arellano and Bonhomme, "Quantile Selection Models"
%%%% This code plots the contours if the estimated Frank copulas, see
%%%% Figure 3 in the paper
%%%% The copula parameters are estimated using Estimation_rho.m

clear 
clc;

%%% Uncomment the line of code, depending on the (gender, marital status)
%%% combination

%m,m
theta=-1.482;

%m,s
%theta=-7.638;

%f,m
%theta=-1.035;

%f,s
%theta=-.4820;

vecu=(.001:.001:.999)';
vecv=(.001:.001:.999)';

vecfrank=-1/theta*log(ones(999,999)+(exp(-theta*vecu*ones(1,999))-1).*(exp(-theta*ones(999,1)*vecv')-1)/(exp(-theta)-1));

vecderfrank=vecfrank(2:999,2:999)-vecfrank(2:999,1:998)-vecfrank(1:998,2:999)+vecfrank(1:998,1:998);

x=icdf('normal',vecu(1:998),0,1);
y=icdf('normal',vecv(1:998),0,1);

vecderfrank=vecderfrank.*pdf('normal',x*ones(1,998),0,1).*pdf('normal',ones(998,1)*y',0,1);

x1=x(2:998);
y1=y(2:998);
z1=vecderfrank(2:998,2:998);
contour(x1,y1,z1,4);



